#ifndef PRIMITIVEEDITOR_H
#define PRIMITIVEEDITOR_H

#include <QWidget>
#include "qglview.h"


namespace Ui {
class PrimitiveEditor;
}


class PrimitiveEditor : public QWidget {
	Q_OBJECT
public:
	enum PrimitiveType {
		Plane,
		Cube,
		Ellipsoid,
		Disc,
		Cone,
		Cylinder,
		Torus
	};
	Q_ENUMS(PrimitiveType)

	explicit PrimitiveEditor(QWidget *parent = nullptr);
	~PrimitiveEditor();

	void assignQGLView(QGLView * v);

protected:
	Mesh * createMesh(QVariantList & params);
	void showEditors();

	Ui::PrimitiveEditor *ui;
	QGLView * view;
	QMap<PrimitiveType, QList<QWidget *> > editors;
	QList<QWidget *> all_editors;
	bool can_replace;

private slots:
	void selectionChanged();
	void replaceMesh();
	void on_buttonAdd_clicked();
	void on_comboPrimitives_currentIndexChanged(int index);
};


#endif // PRIMITIVEEDITOR_H
